Questo_API = {
	lib = {},
	locale = {},
};

Questo_API.locale.info = {

	["enUS"] = {
		localeText = "English",
		localeContent = {
			Q_Questo = "Questo",
			Q_SELECT_DIALOG_OPTION = "Select dialog option",
			Q_SELECT_AVAILABLE_QUEST = "Select available quest",
			Q_NEXT = "Continue",
			Q_CONTINUE = "Complete quest",
			Q_NOT_YET = "Come back when it's done",
			Q_CHECK_OBJ = "Check objectives",
			Q_REWARD_MORE = "You will also get",
			Q_REWARD_MORE_SUB = "\nMoney: |cffffffff%s|r\nExperience: |cffffffff%s xp|r\n\n|cffffff00Click:|r Get your reward!",
			Q_GET_REWARD = "Get your reward",
			Q_SELECT_REWARD = "Select your reward",
			Q_CONFIG = "Settings",
			Q_CONFIG_WELCOME = [[ALPHA 0.7]],
			Q_CONFIG_LANGUAGE = "Language",
			Q_CONFIG_TEXTSPEED_TITLE = "Text animation speed",
			Q_CONFIG_TEXTSPEED = "%.1fx",
			Q_CONFIG_TEXTSPEED_INSTANT = "No animation",
			Q_CONFIG_TEXTSPEED_HIGH = "Fast",
			Q_CONFIG_FORCEGOSSIP = "Show flavor texts",
			Q_CONFIG_FORCEGOSSIP_TT = "Show flavor texts on NPCs like merchants or fly masters.",
			Q_CONFIG_BIG_SAMPLE_TEXT = [[The Scarlet Monastery is one of four strongholds in the world belonging to the fanatical Scarlet Crusade, the others being the Scarlet Bastion within the ruins of Stratholme, the town of Hearthglen, and the town of Tyr's Hand. Located in the northeast corner of the blighted Tirisfal Glades, the Scarlet Monastery was once a cathedral to the Light, now taken over by zealots. The Scarlet Monastery is a complex of four wings, each an instanced dungeon, for both Horde and Alliance characters. The mobs respawn at the same rate in each of them, except for the Cathedral.]],
			Q_CONFIG_NEXT_ACTION = "Next action",
			Q_CONFIG_DIALOG_CHOICES = "Dialog choices",
		}
	},

}

local error, tostring = error, tostring;

local LOCALS = Questo_API.locale.info;
local DEFAULT_LOCALE = "enUS";
Questo_API.locale.DEFAULT_LOCALE = DEFAULT_LOCALE;
local effectiveLocal = {};
local localeFont;
local current;

function Questo_API.locale.init()

	current = Questo_Data.config.locale or GetLocale();
	if not LOCALS[current] then
		current = DEFAULT_LOCALE;
	end
	if current == "zhCN" then
		localeFont = "Fonts\\ARKai_T.TTF";
	elseif current == "zhTW" then
		localeFont = "Fonts\\bLEI00D.TTF";
	elseif current == "ruRU" then
		localeFont = "Fonts\\FRIZQT___CYR.TTF";
	elseif current == "koKR" then
		localeFont = "Fonts\\2002.TTF";
	else
		localeFont = "Fonts\\FRIZQT__.TTF";
	end
	effectiveLocal = LOCALS[current].localeContent;

	Questo_Data.config.locale = current;
	Questo_API.locale.localeFont = localeFont;
end

local function getText(key)
	if effectiveLocal[key] or LOCALS[DEFAULT_LOCALE].localeContent[key] then
		return effectiveLocal[key] or LOCALS[DEFAULT_LOCALE].localeContent[key];
	end
	error("Unknown localization key: ".. tostring(key));
end
Questo_API.locale.getText = getText;

function Questo_API.locale.getLocales()
	return Questo_API.locale.info;
end
